.macro xor rs rx ry
        or \rs, \rx, \ry
        push \rs
        and \rs, \rx, \ry
        move \ry, \rs
        pop \rx
        sub \rs, \rx, \ry
.endm

.macro push rx
	st \rx,r3,0
	sub r3,r3,1
.endm

.macro pop rx
	add r3,r3,1
	ld \rx,r3,0
.endm

.macro psr sr=r1 pos=.
	.set _next2,(\pos+16)
	move \sr,_next2
	push \sr
.endm

.macro ret sr=r1
	pop \sr
	jump \sr
.endm

.macro GPIO_IN
	psr
	jump set_in_one_wire_pin
.endm

.macro GPIO_OUT
	psr
	jump set_out_one_wire_pin
.endm

.macro GPIO_HIGH
	psr
	jump set_one_wire_pin
.endm

.macro GPIO_LOW
	psr
	jump clear_one_wire_pin
.endm
